<?php
namespace Teknisa\PLA\Modules\Cardapio\Controllers;
/**
 * 01/06/2015
 * @author Francis
 */

use \Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DataSource;
use \Zeedhi\Framework\DTO\Request\Filter;
use \Zeedhi\Framework\DTO\Response;

class ImportarCardapio extends \Zeedhi\Framework\Controller\Simple {

	const FERIADO_BLOQUEADO = 'S';
	
	protected $importarCardapio;

    public function __construct($importarCardapio) {
        $this->importarCardapio = $importarCardapio;
    }

    private function retornaColunaSemana($diaDaSemana) {
        
        $diasDaSemana = array(
            '0' => 'DOM','1' => 'SEG',
            '2' => 'TER','3' => 'QUA',
            '4' => 'QUI','5' => 'SEX',
            '6' => 'SAB','7' => 'FER',
        );

        return $diasDaSemana[$diaDaSemana];
    }

	public function importarCardapioDoDia($request, $response) {
		try {
			
			$parametros = $request->getFilterCriteria()->getConditions();

			$cardapios = $parametros[0]['value'];
			$servicoDestino = $parametros[1]['value'];
			$idcardiautil = $parametros[2]['value'];
			$unidadeOrigem = $parametros[3]['value'];
			$servicoOrigem = $parametros[4]['value'];
			$montagem = $parametros[5]['value'];
			$idpratoespe = $parametros[6]['value'];
			$idcarddescentr = $parametros[7]['value'] == 'S' ? true : false;
			$filialDestino = $parametros[8]['value'];
			$diasInvalidos = "";
			
			$idUtrPadca = $this->importarCardapio->retornaParamgeral()["IDUTRPADCA"];
			foreach ($cardapios as $cardapio) {
				$dtdestino = explode(",", $cardapio['DTDESTINO']);
				$dataCardapioDestino = $dtdestino[0];
				$diaSemanaDestino = $this->retornaColunaSemana($cardapio['DIASEMANADESTINO']);

				$dtdestino = explode(",", $cardapio['DTCARDAPIO']);
				$dataCardapioOrigem = $dtdestino[0];
				$diaSemanaOrigem = $this->retornaColunaSemana($cardapio['DIASEMANACARDAPIO']);
				
				$diaCardapio = array(
					"DATA" => $dataCardapioOrigem,
					"CDFILIAL" => $unidadeOrigem,
					"CDSERVFILI" => $servicoOrigem
				);
				$pratosInativos = $this->importarCardapio->getIdAtivoPratosReceitasDia($diaCardapio);
				if(!empty($pratosInativos)) {
					$diasInvalidos = $diasInvalidos."<br>".$diaCardapio['DATA'];
				} else {
					if($idcardiautil == self::FERIADO_BLOQUEADO) {
						if($cardapio['IDCARDIAUTIL'] != self::FERIADO_BLOQUEADO) {
							$this->importarCardapio->importarCardapioDoDia($idpratoespe, $idcarddescentr, $dataCardapioOrigem, $montagem, $servicoDestino, $servicoOrigem, $dataCardapioDestino, $diaSemanaDestino, $cardapio['NRCARDAPIO'], $unidadeOrigem, $filialDestino, $idUtrPadca);
						}
					} else {
						$this->importarCardapio->importarCardapioDoDia($idpratoespe, $idcarddescentr, $dataCardapioOrigem, $montagem, $servicoDestino, $servicoOrigem, $dataCardapioDestino, $diaSemanaDestino, $cardapio['NRCARDAPIO'], $unidadeOrigem, $filialDestino, $idUtrPadca);
					}
				}
			}
			if($diasInvalidos) {
				$response->addDataSet(new DataSource\DataSet("errorMsg", array($diasInvalidos)));
				throw new \Exception($diasInvalidos);
			}
		} catch(\Exception $e) {
			$response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}